	LIST P=16F628, R=DEC
	INCLUDE<P16F628.INC>

	__CONFIG _PWRTE_ON & _WDT_OFF & _MCLRE_OFF & _BODEN_OFF & _LVP_OFF & _INTRC_OSC_NOCLKOUT

W_save	equ	20h		; zaloha pri preruseni
Sta_sav	equ	21h		; zaloha pri preruseni
PCL_sav	equ	22h		; zaloha pri preruseni
FSR_sav	equ	23h		; zaloha pri preruseni

PSTOP	equ	24h		; pauza pred fotenim
DSTOP	equ	25h		; pauza pred fotenim (default sekundy)

COUNTA	equ	26h		; casovac 1 sekunda
COUNTB	equ	27h		;    -//-
COUNTC	equ	28h		;   -//-
COUNTD	equ	29h		;  -//-

STO	equ	2Ah		;registre pre otocenie
DES	equ	2Bh		;
JED	equ	2Ch		;
DSTO	equ	2Dh		;
DDES	equ	2Eh		;
DJED	equ	2Fh		;registre pre otocenie

RDES	equ	30h		;registre pre rychlost
RJED	equ	31h		;
DRDES	equ	32h		;
DRJED	equ	33h		;

s_copy	Equ	34h
LcdDaten	Equ	35h
LcdStatus	Equ	36h
loops	EQU	37h
loops2	EQU	38h
kurzor	EQU	39h

UDSTO	equ	3Ah		;otocenie default stovky
UDDES	equ	3Bh		;otocenie default desiatky
UDJED	equ	3Ch

timdis	equ	3Dh		;  casovac pre display

FOTDES	equ	3Eh		; dlzka fotenia
FOTJED	equ	3Fh		; dlzka fotenia (default sekundy)

RDEFDES	equ	40h		;rychlost otacania default desiatky
RDEFJED	equ	41h		;rychlost otacania default jednotky

NASTR	equ	42h		;Nastavenie smeru rotacie
ROTAC	equ	43h
LOHI	equ	44h

POCJED	equ	45h
POCDES	equ	46h
POCSTO	equ	47h
kurzor2	equ	48h

POCJE2	equ	49h
POCDE2	equ	4Ah
POCST2	equ	4Bh
POCTI2	equ	4Ch
POCPRE	equ	4Dh

CISLO	equ	4Fh	; data pro zapis do EEPROM
EADR	equ	50h	; adresa pro EEPROM
NASTR2	equ	51h
ZRYCHL 	equ	52h

PORTC	equ	PORTB		; LCD-Control-Port
PORTD	equ	PORTB		; LCD-Data-Port
LcdE	equ	3		; enable Lcd
LcdRs	equ	1		; Datea Lcd (control)	
LcdRW	equ	2
Ini_opt	Equ	B'00000010'	; pull-up



#DEFINE	FOT	PORTA,0
#DEFINE	DIR	PORTA,1
#DEFINE	CLK	PORTA,2
#DEFINE	LH	PORTA,3

;------------------------Nahratie EEPROM Pri Programoani
org 0x2100
de 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
de 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00

;-----------------------------------nastavenia pre prerusenie

	org	00h
	goto	INIT

	org	04h		; ulozenie hlavnych registrov
	movwf	W_save		; W
	movf	STATUS,W
	clrf	STATUS		; Banka 0
	movwf	Sta_sav		; STATUS
	movf	PCLATH,w
	movwf	PCL_sav		; PCLATH
	movf	FSR,w
	movwf	FSR_sav		; FSR
	GOTO	PRERUS

;*******************Inicializacia procesora

INIT	MOVLW	B'00000111'	; typ komparatora (off)
	MOVWF	CMCON
	BSF	STATUS,RP0	; nastavenie In / Out
	movlw   Ini_opt     	; pull-up on
	movwf   OPTION_REG 
	MOVLW	B'11110000'
	MOVWF	TRISA
	MOVLW	B'00000001'
	MOVWF	TRISB
	BCF	STATUS,RP0
	clrf	PORTA		
	clrf	PORTB	
;------------------------------------------
clrf kurzor	
clrf kurzor2
;------------------------------------------
	MOVLW	0		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	UDSTO
	MOVLW	1		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	UDDES
	MOVLW	2		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	UDJED
	MOVLW	3		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	DSTOP
	MOVLW	4		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	FOTDES
	MOVLW	5		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	FOTJED
	MOVLW	6		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	RDEFDES	
	MOVLW	7		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	RDEFJED	
	MOVLW	8		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	NASTR
	MOVLW	9		; Citanie dat z eeprom
	MOVWF	EADR
	CALL	CTIEE
	MOVWF	LOHI


	call	InitLCD		; Inicializacia displaya

	MOVLW	B'01000000'	;znak Hore/dole
	CALL	OutLcdControl	
	movlw	0x4
	call	OutLcdDaten
	movlw	0xe
	call	OutLcdDaten
	movlw	0x1f
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x1f
	call	OutLcdDaten
	movlw	0xe
	call	OutLcdDaten
	movlw	0x4
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	
	MOVLW	B'01001000'	;znak Hore
	CALL	OutLcdControl	
	movlw	0x4
	call	OutLcdDaten
	movlw	0xe
	call	OutLcdDaten
	movlw	0x1f
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten

	MOVLW	B'01010000'	;znak dole
	CALL	OutLcdControl	
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten
	movlw	0x1f
	call	OutLcdDaten
	movlw	0xe
	call	OutLcdDaten
	movlw	0x4
	call	OutLcdDaten
	movlw	0x0
	call	OutLcdDaten

	CALL	WELCOM
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER
	CALL	TIMER

	MOVLW	B'10010000'	; povolenie preruseni od RB0
	MOVWF	INTCON

	BSF	INTCON,1
;----------------------Nastavenie smeru a Full/Half

ZNOVA	MOVLW	0		;  smer rotacie
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	BSF	DIR
	MOVLW	1
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	BCF	DIR
	MOVLW	2
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	CALL	UPDOWN
	
	CALL	DISPZOBRAZ
	
;-------------motor zastaveny, casocac pred fotenim
	MOVLW	0
	XORWF	DSTOP,W
	BTFSC	STATUS,Z		
	GOTO	FFOOT
	MOVFW	DSTOP		; nahratie hodnoty z registra
	MOVWF	PSTOP
	CALL	TIMER
	DECFSZ	PSTOP,1
	GOTO	$-2
				;koniec pauzy pre fotenim
;-------------motor zastaveny, fotenie
FFOOT	MOVFW	FOTDES
	MOVWF	DRDES
	INCF 	DRDES,1	
	MOVFW	FOTJED
	MOVWF	DRJED
	INCF 	DRJED,1		

	BSF	FOT		;fotenie start
	
	MOVLW	D'10'
	MOVWF	RDES

TIMDES	DECFSZ	DRDES,1
	GOTO	DESIA

TIMJED	DECFSZ	DRJED,1		
	GOTO	JEDNO	
	
	CALL	POCITA
	BCF	FOT
	CALL	DISPZOBRAZ
	
	movlw	D'100'		; oneskorenie po skonceni fotenia
	movwf	loops	
	CALL	WAIT
	
	MOVFW	UDSTO		;start otacania
	MOVWF	DSTO		;nacitanie nastavenia otocenia
	INCF 	DSTO,1
	MOVFW	UDDES
	MOVWF	DDES
	INCF 	DDES,1
	MOVFW	UDJED
	MOVWF	DJED
	
TOCSTO	DECFSZ	DSTO,1		;otacanie stovky
	GOTO	STOVKA
TOCDES	DECFSZ	DDES,1		;otacanie desiatky
	GOTO	DESIAT
	
TOCJED	MOVLW	D'0'		
	XORWF	DJED,W		
	BTFSC	STATUS,Z		
	GOTO	$+4
	DECF	DJED,f
	CALL	TOC		;otacanie jednotky
	GOTO	TOCJED

	GOTO	ZNOVA

;----koniec hlavnej smycky pre vykonavanie rotacie


DESIA	CALL	TIMER
	DECFSZ	RDES,1
	GOTO	DESIA
	
	MOVLW	D'10' 	;oprava vo firmware 1.1
	MOVWF	RDES

	GOTO	TIMDES

JEDNO	CALL	TIMER
	GOTO	TIMJED

;-------------------pocitadlo fotografii------------------------
POCITA	MOVLW	D'9'		
	XORWF	POCJED,W		
	BTFSC	STATUS,Z		
	GOTO	POCDE	
	INCF	POCJED,f
	RETURN

POCDE	MOVLW	D'9'		
	XORWF	POCDES,W		
	BTFSC	STATUS,Z		
	GOTO	POCST	
	INCF	POCDES,f
	CLRF	POCJED
	RETURN

POCST	MOVLW	D'9'		
	XORWF	POCSTO,W		
	BTFSC	STATUS,Z		
	GOTO	POCRES	
	INCF	POCSTO,f
	CLRF	POCJED
	CLRF	POCDES
	RETURN

POCRES	CLRF	POCJED
	CLRF	POCDES
	CLRF	POCSTO
	RETURN

;---------------------POCITACLO OTOCENIA---------------------
POCIT2	BTFSS	LH
	GOTO	$+4
	MOVLW	D'1'
	MOVWF	POCPRE
	GOTO	POCITR
	MOVLW	D'2'
	MOVWF	POCPRE

POCITR	MOVLW	D'9'		
	XORWF	POCJE2,W		
	BTFSC	STATUS,Z		
	GOTO	POCD2	
	INCF	POCJE2,f
	GOTO	PREVOD

POCD2	MOVLW	D'9'		
	XORWF	POCDE2,W		
	BTFSC	STATUS,Z		
	GOTO	POCS2	
	INCF	POCDE2,f
	CLRF	POCJE2
	GOTO	PREVOD

POCS2	MOVLW	D'3'		
	XORWF	POCST2,W		
	BTFSC	STATUS,Z		
	GOTO	POCIT2R	
	INCF	POCST2,f
	CLRF	POCJE2
	CLRF	POCDE2
	GOTO	PREVOD

POCIT2R	CLRF	POCJE2
	CLRF	POCDE2
	CLRF	POCST2
		
	

PREVOD				;----nasobenie podla kroku
	DECFSZ	POCPRE,1
	GOTO	POCITR
	RETURN
	

;-------------RESET POCITADIEL
CLEAR	
	CLRF	POCJE2
	CLRF	POCDE2
	CLRF	POCST2
	CLRF	POCTI2
	CLRF	POCJED
	CLRF	POCDES
	CLRF	POCSTO
	RETURN

;---------------------------------------------Prerusenie

PRERUS	CALL	TIMER3
	BCF	INTCON,1
	BCF	FOT		;zrusi prebiehajuce fotenie 
	
TLZOB
	MOVLW	B'00000001'	;zmaze celu obrazovku
	CALL	OutLcdControl
	
	
	MOVLW	D'0'		
	XORWF	kurzor2,W		
	BTFSC	STATUS,Z		
	CALL	DISPMANUAL
	MOVLW	D'1'		
	XORWF	kurzor2,W		
	BTFSC	STATUS,Z		
	CALL	DISPSETUP
	MOVLW	D'2'		
	XORWF	kurzor2,W		
	BTFSC	STATUS,Z		
	CALL	DISPRUN

TL1					;<<< obsluha tlacitek >>>
TL1SM	BTFSC	PORTB,0
	GOTO	TLenter1	;ENTER
	BTFSC	PORTA,6
	GOTO	TLhore1		;hore
	BTFSC	PORTA,7
	GOTO	TLdole1		;dole
	GOTO	TL1SM


TLdole1	CALL	TIMER3
	MOVLW	D'0'			;<<< ochrana preteceni >>>
	XORWF	kurzor2,W		;porovnani reg. s 0xC2
	BTFSC	STATUS,Z
	GOTO	TL1
	DECF	kurzor2,f
	GOTO	TLZOB

TLhore1	CALL	TIMER3
	MOVLW	D'2'			;<<< ochrana preteceni >>>
	XORWF	kurzor2,W		;porovnani reg. s 0xC2
	BTFSC	STATUS,Z
	GOTO	TL1
	INCF	kurzor2,f
	GOTO	TLZOB




TLenter1
	CALL	TIMER3
	CALL	TIMER3
	CALL	CLEAR	
	
	MOVLW	0		;  plny alebo polovicny krok
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	BCF	LH
	MOVLW	1
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	BSF	LH
	
	MOVLW	D'0'		
	XORWF	kurzor2,W		
	BTFSC	STATUS,Z		
	GOTO	MANUAL
	MOVLW	D'1'		
	XORWF	kurzor2,W		
	BTFSC	STATUS,Z		
	GOTO	SETUP
	GOTO	PRERKON
	

;--------------------------------------------------
SETUP	
	CALL	DISPNASTAV

	MOVLW	B'11000010'
	MOVWF	kurzor			;posunut kurzoru na udanou polohu
	CALL	OutLcdControl
	MOVLW	B'00001101'		;zacne blikat display
	CALL	OutLcdControl
	GOTO IMPULSES

TL	CALL	TIMER3				;<<< obsluha tlacitek >>>
TLSM	BTFSC	PORTA,4		
	GOTO	TLvlavo		;vlavo
	BTFSC	PORTA,5
	GOTO	TLvpravo	;vpravo
	BTFSC	PORTB,0
	GOTO	TLenter		;ENTER
	BTFSC	PORTA,6
	GOTO	TLhore		;hore
	BTFSC	PORTA,7
	GOTO	TLdole		;dole
	GOTO	TLSM
;--------------------------------------------------
TLvlavo
	
	MOVLW	B'11000000'		;<<< ochrana pretecenia >>>
	XORWF	kurzor,W		;porovnanie reg. s 0xC2
	BTFSC	STATUS,Z		;ak neni na zaciatku ide sa na dekrementaciu
	GOTO	TLendL			
	GOTO	NAPDOWN

TLendL					;ak je kurzor na zaciatku skok na koniec
	MOVLW	B'11001111'
	MOVWF	kurzor
	CALL	OutLcdControl
	GOTO	HFSTEP

TLvpravo
	MOVLW	B'11001111'			;<<< ochrana pretecenia >>>
	XORWF	kurzor,W		;porovnanie reg. s 0xC5
	BTFSC	STATUS,Z		;ak neni na konci ide sa na inkrementaciu
	GOTO	TLendR
	GOTO	NAPUP

TLendR					;ak je kurzor na konci skok na zaciatok
	MOVLW	B'11000000'
	MOVWF	kurzor
	CALL	OutLcdControl
	GOTO	IMPULSES


;------------------------------napovedne texty
NAPDOWN
	MOVLW	B'11000101'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	IMPULSED
	MOVLW	B'11001000'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	PAUSEDISD
	MOVLW	B'11001011'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	EXPDISD
	MOVLW	B'11001110'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	DIRECDISD
	MOVLW	B'11001111'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	HFSTED
	
	DECF	kurzor,f		;<<< uprava hodnoty >>>registr kurzor - 1
	MOVFW	kurzor
	CALL	OutLcdControl
	GOTO	TL

NAPUP	MOVLW	B'11000010'	
	XORWF	kurzor,W		
	BTFSC	STATUS,Z	
	GOTO	SPEEH
	MOVLW	B'11000110'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	PAUSEDISH
	MOVLW	B'11001000'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	EXPDISH
	MOVLW	B'11001100'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	DIRECDISH	
	MOVLW	B'11001110'		
	XORWF	kurzor,W		
	BTFSC	STATUS,Z		
	GOTO	HFSTEH

	INCF	kurzor,f		;<<< uprava hodnoty >>>registr kurzor + 1
	MOVFW	kurzor
	CALL	OutLcdControl
	GOTO	TL

	
	
	
	
	
;--------Preskakovanie pozicii na display, ktore sa nepouzivaju
SPEEH	
	INCF	kurzor,f
	INCF	kurzor,f
	INCF	kurzor,f
	GOTO	SPEED
IMPULSED	
	DECF	kurzor,f
	DECF	kurzor,f
	DECF	kurzor,f
	GOTO	IMPULSES
PAUSEDISH	
	INCF	kurzor,f
	INCF	kurzor,f
	GOTO	PAUSEDISP	
PAUSEDISD
	DECF	kurzor,f
	DECF	kurzor,f
	GOTO	SPEED
EXPDISH	
	INCF	kurzor,f
	INCF	kurzor,f
	INCF	kurzor,f
	GOTO	EXPDISP
EXPDISD	
	DECF	kurzor,f
	DECF	kurzor,f
	DECF	kurzor,f
	GOTO	PAUSEDISP
DIRECDISH
	INCF	kurzor,f
	INCF	kurzor,f
	GOTO	DIRECDISP
DIRECDISD	
	DECF	kurzor,f
	DECF	kurzor,f
	GOTO	EXPDISP
HFSTEH
	INCF	kurzor,f
	GOTO	HFSTEP
HFSTED
	DECF	kurzor,f
	GOTO	DIRECDISP


;----------------------------------
TLhore
		MOVLW	B'11000000'			;ak je kurzor na pozicii (1)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCSTO_H
		MOVLW	B'11000001'			;ak je kurzor na pozicii (2)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCDES_H
		MOVLW	B'11000010'			;ak je kurzor na pozicii (3)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCJED_H
		MOVLW	B'11000101'			;ak je kurzor na pozicii (6)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	SPDDES_H
		MOVLW	B'11000110'			;ak je kurzor na pozicii (7)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	SPDJED_H
		MOVLW	B'11001000'			;ak je kurzor na pozicii (9)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	PAUSE_H
		MOVLW	B'11001011'			;ak je kurzor na pozicii (12)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	FOTIDES_H
		MOVLW	B'11001100'			;ak je kurzor na pozicii (13)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	FOTIJED_H
		MOVLW	B'11001110'			;ak je kurzor na pozicii (13)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	NASTROT_H
		MOVLW	B'11001111'			;ak je kurzor na pozicii (14)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	LOWHIGH_H
		GOTO	TL

	
TLdole
		MOVLW	B'11000000'			;ak je kurzor na pozicii (1)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCSTO_D
		MOVLW	B'11000001'			;ak je kurzor na pozicii (2)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCDES_D
		MOVLW	B'11000010'			;ak je kurzor na pozicii (3)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	OTOCJED_D
		MOVLW	B'11000101'			;ak je kurzor na pozicii (6)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	SPDDES_D
		MOVLW	B'11000110'			;ak je kurzor na pozicii (7)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	SPDJED_D
		MOVLW	B'11001000'			;ak je kurzor na pozicii (9)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	PAUSE_D
		MOVLW	B'11001011'			;ak je kurzor na pozicii (12)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	FOTIDES_D
		MOVLW	B'11001100'			;ak je kurzor na pozicii (13)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	FOTIJED_D
		MOVLW	B'11001110'			;ak je kurzor na pozicii (15)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	NASTROT_D
		MOVLW	B'11001111'			;ak je kurzor na pozicii (14)
		XORWF	kurzor,W
		BTFSC	STATUS,Z
			GOTO	LOWHIGH_D	
		GOTO	TL


TLenter				;koniec nastavovania
	MOVLW	B'00001100'
	CALL	OutLcdControl	;vypne blikanie kurzora
	
		
	MOVLW	0		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	UDSTO
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	1		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	UDDES
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	2		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	UDJED
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	3		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	DSTOP
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	4		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	FOTDES
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	5		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	FOTJED
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	6		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	RDEFDES
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	7		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	RDEFJED
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	8		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	NASTR
	MOVWF	CISLO
	CALL	PISEE

	MOVLW	9		;pozicia v EEprom
	MOVWF	EADR
	MOVFW	LOHI
	MOVWF	CISLO
	CALL	PISEE

	GOTO	TLZOB
	

;-----------------Inkrementacia hodnot
OTOCSTO_H
		MOVLW	9		;maximalna hodnota pozicie
		XORWF	UDSTO,W		;porovnanie s registrom
		BTFSC	STATUS,Z
		GOTO	OTOCSTE_H	;ak je vacsia ako 9 vynulovat
		INCF	UDSTO,f		;inkrementacia hodnoty
		MOVFW	UDSTO		
		GOTO	INCDECZOB	;skok na obrazenie na display
OTOCSTE_H	MOVLW	0		; nulovanie hodnoty
		MOVWF	UDSTO
		GOTO	INCDECZOB	;skok na zobrazenie

OTOCDES_H
		MOVLW	9
		XORWF	UDDES,W
		BTFSC	STATUS,Z
		GOTO	OTOCDEE_H
		INCF	UDDES,f
		MOVFW	UDDES
		GOTO	INCDECZOB
OTOCDEE_H	MOVLW	0
		MOVWF	UDDES
		GOTO	INCDECZOB

OTOCJED_H
		MOVLW	9
		XORWF	UDJED,W
		BTFSC	STATUS,Z
		GOTO	OTOCJEE_H
		INCF	UDJED,f
		MOVFW	UDJED
		GOTO	INCDECZOB
OTOCJEE_H	MOVLW	0
		MOVWF	UDJED
		GOTO	INCDECZOB

SPDDES_H
		MOVLW	9
		XORWF	RDEFDES,W
		BTFSC	STATUS,Z
		GOTO	SPDDEE_H
		INCF	RDEFDES,f
		MOVFW	RDEFDES
		GOTO	INCDECZOB
SPDDEE_H	MOVLW	0
		MOVWF	RDEFDES
		GOTO	INCDECZOB

SPDJED_H
		MOVLW	9
		XORWF	RDEFJED,W
		BTFSC	STATUS,Z
		GOTO	SPDJEE_H
		INCF	RDEFJED,f
		MOVFW	RDEFJED
		GOTO	INCDECZOB
SPDJEE_H	MOVLW	0
		MOVWF	RDEFJED
		GOTO	INCDECZOB


PAUSE_H
		MOVLW	9
		XORWF	DSTOP,W
		BTFSC	STATUS,Z
		GOTO	PAUSEE_H
		INCF	DSTOP,f
		MOVFW	DSTOP
		GOTO	INCDECZOB
PAUSEE_H	MOVLW	0
		MOVWF	DSTOP
		GOTO	INCDECZOB


FOTIDES_H
		MOVLW	9
		XORWF	FOTDES,W
		BTFSC	STATUS,Z
		GOTO	FOTIDEE_H
		INCF	FOTDES,f
		MOVFW	FOTDES
		GOTO	INCDECZOB
FOTIDEE_H	MOVLW	0
		MOVWF	FOTDES
		GOTO	INCDECZOB


FOTIJED_H
		MOVLW	9
		XORWF	FOTJED,W
		BTFSC	STATUS,Z
		GOTO	FOTIJEE_H
		INCF	FOTJED,f
		MOVFW	FOTJED
		GOTO	INCDECZOB
FOTIJEE_H	MOVLW	0
		MOVWF	FOTJED
		GOTO	INCDECZOB

NASTROT_H
		MOVLW	2
		XORWF	NASTR,W
		BTFSC	STATUS,Z
		GOTO	NASTEND_H
		INCF	NASTR,f
		CALL	DIRECT
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL
NASTEND_H
		MOVLW	0
		MOVWF	NASTR
		CALL	DIRECT
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL
LOWHIGH_H
		MOVLW	1
		XORWF	LOHI,W
		BTFSC	STATUS,Z
		GOTO	LOWHEND_H
		INCF	LOHI,f
		CALL	FULLHALF
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL
LOWHEND_H
		MOVLW	0
		MOVWF	LOHI
		CALL	FULLHALF
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL

	

;----------dekrementacia hodnot
OTOCSTO_D
		MOVLW	0
		XORWF	UDSTO,W
		BTFSC	STATUS,Z
		GOTO	OTOCSTE_D
		DECF	UDSTO,f
		MOVFW	UDSTO
		GOTO	INCDECZOB
OTOCSTE_D	MOVLW	9
		MOVWF	UDSTO
		GOTO	INCDECZOB

OTOCDES_D
		MOVLW	0
		XORWF	UDDES,W
		BTFSC	STATUS,Z
		GOTO	OTOCDEE_D
		DECF	UDDES,f
		MOVFW	UDDES
		GOTO	INCDECZOB
OTOCDEE_D	MOVLW	9
		MOVWF	UDDES
		GOTO	INCDECZOB

OTOCJED_D
		MOVLW	0
		XORWF	UDJED,W
		BTFSC	STATUS,Z
		GOTO	OTOCJEE_D
		DECF	UDJED,f
		MOVFW	UDJED
		GOTO	INCDECZOB
OTOCJEE_D	MOVLW	9
		MOVWF	UDJED
		GOTO	INCDECZOB


SPDDES_D
		MOVLW	0
		XORWF	RDEFDES,W
		BTFSC	STATUS,Z
		GOTO	SPDDEE_D
		DECF	RDEFDES,f
		MOVFW	RDEFDES
		GOTO	INCDECZOB
SPDDEE_D	MOVLW	9
		MOVWF	RDEFDES
		GOTO	INCDECZOB

SPDJED_D
		MOVLW	0
		XORWF	RDEFJED,W
		BTFSC	STATUS,Z
		GOTO	SPDJEE_D
		DECF	RDEFJED,f
		MOVFW	RDEFJED
		GOTO	INCDECZOB
SPDJEE_D	MOVLW	9
		MOVWF	RDEFJED
		GOTO	INCDECZOB

PAUSE_D
		MOVLW	0
		XORWF	DSTOP,W
		BTFSC	STATUS,Z
		GOTO	PAUSEE_D
		DECF	DSTOP,f
		MOVFW	DSTOP
		GOTO	INCDECZOB
PAUSEE_D	MOVLW	9
		MOVWF	DSTOP
		GOTO	INCDECZOB

FOTIDES_D
		MOVLW	0
		XORWF	FOTDES,W
		BTFSC	STATUS,Z
		GOTO	FOTIDEE_D
		DECF	FOTDES,f
		MOVFW	FOTDES
		GOTO	INCDECZOB
FOTIDEE_D	MOVLW	9
		MOVWF	FOTDES
		GOTO	INCDECZOB

FOTIJED_D
		MOVLW	0
		XORWF	FOTJED,W
		BTFSC	STATUS,Z
		GOTO	FOTIJEE_D
		DECF	FOTJED,f
		MOVFW	FOTJED
		GOTO	INCDECZOB
FOTIJEE_D	MOVLW	9
		MOVWF	FOTJED
		GOTO	INCDECZOB

NASTROT_D
		MOVLW	0
		XORWF	NASTR,W
		BTFSC	STATUS,Z
		GOTO	NASTEND_D
		DECF	NASTR,f
		CALL	DIRECT
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL
NASTEND_D
		MOVLW	2
		MOVWF	NASTR
		CALL	DIRECT
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL

LOWHIGH_D
		MOVLW	0
		XORWF	LOHI,W
		BTFSC	STATUS,Z
		GOTO	LOWHEND_D
		DECF	LOHI,f
		CALL	FULLHALF
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL
LOWHEND_D
		MOVLW	1
		MOVWF	LOHI
		CALL	FULLHALF
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL

INCDECZOB
		movwf	LcdDaten
		CALL	OutLcdNumber
		MOVFW	kurzor
		CALL	OutLcdControl
		GOTO	TL	

;---------------Koniec prerusenia
PRERKON	MOVLW	B'10010000'	; povolenie pozadovanych preruseni
	MOVWF	INTCON
	clrf	STATUS		; Banka 0 obnovenie ulozenych registrov
	movf	FSR_sav,w	; FSR
	movwf	FSR
	movf	PCL_sav,w	; PCLATH
	movwf	PCLATH
	movf	Sta_sav,w	; Status
	movwf	STATUS
	swapf	W_save,f	; W
	swapf	W_save,w
	GOTO	ZNOVA
	retfie

;---------------nasobky krat 10,100 pre otocenie
STOVKA	MOVLW	D'100'
	MOVWF	STO
	CALL	TOC
	DECFSZ	STO,1
	GOTO	$-2
	GOTO	TOCSTO

DESIAT	MOVLW	D'10'
	MOVWF	DES	
	CALL	TOC
	DECFSZ	DES,1
	GOTO	$-2
	GOTO	TOCDES

;--------------------------------------rotacia
TOC	MOVFW	RDEFDES
	MOVWF	DRDES
	INCF 	DRDES,1	
	MOVFW	RDEFJED
	MOVWF	DRJED
	INCF 	DRJED,1	

	MOVLW	D'100'
	MOVWF	RDES
	CALL	TIM2
	DECFSZ	RDES,1
	GOTO	$-2
	DECFSZ	DRDES,1		
	GOTO	$-6

	MOVLW	D'10'
	MOVWF	RJED
	CALL	TIM2
	DECFSZ	RJED,1
	GOTO	$-2
	DECFSZ	DRJED,1		
	GOTO	$-6


	BSF	CLK		;clk log1
	CLRF	RDES
	INCFSZ	RDES,1		;pevny casovac dlzky impulzu
	GOTO	$-1
	CALL	POCIT2
	BCF	CLK		;clk log0
	RETURN

;----------------------------casovac pre rychlost otacania

TIM2				
	MOVLW	D'50'
	MOVWF	COUNTA
LOOP2	DECFSZ	COUNTA,1
	GOTO	LOOP2
	RETURN

;---------------Podprogram Time Delay 1 sec 0,9961620 sec

TIMER	MOVLW	D'1'
	MOVWF	COUNTD
	MOVLW	D'6'
	MOVWF	COUNTC
	MOVLW	D'19'
	MOVWF	COUNTB
	MOVLW	D'167'
	MOVWF	COUNTA
LOOP	DECFSZ	COUNTA,1
	GOTO	LOOP
	DECFSZ	COUNTB,1
	GOTO	LOOP
	DECFSZ	COUNTC,1
	GOTO	LOOP
	DECFSZ	COUNTD,1
	GOTO	LOOP
	RETURN	

;**********************************************************
;---------------Podprogram Time Delay pre klavesnicu
TIMER3	MOVLW	D'3'
	MOVWF	COUNTC
	MOVLW	D'50'
	MOVWF	COUNTB
	MOVLW	D'50'
	MOVWF	COUNTA
LOOP3	DECFSZ	COUNTA,1
	GOTO	LOOP3
	DECFSZ	COUNTB,1
	GOTO	LOOP3
	DECFSZ	COUNTC,1
	GOTO	LOOP3
	RETURN	

;**********************************************************	
; Inicializacia displaya

InitLCD
	movlw	D'255'		; 250 ms Pausa
	movwf	loops	
	call	WAIT		

	movlw	B'00110000'	; 1
	movwf	PORTB
	bsf	PORTB, LcdE
	nop	
	bcf	PORTB, LcdE
	
	movlw	D'50'		; 50 ms Pausa
	movwf	loops
	call	WAIT
	
	movlw	B'00110000'	; 2
	call	Control8Bit
	movlw	B'00110000'	; 3
	call 	Control8Bit
	movlw	B'00100000'	; 4
	call 	Control8Bit

	movlw	B'00000001'	; l cusor home
	call	OutLcdControl	
	movlw	B'00101000'	; 5 function set, 4-bit  2-riadkovy,  5x7
	call	OutLcdControl	
	movlw	B'00001000'	; 6 display off
	call	OutLcdControl
	movlw	B'00000110'	; 7 increment, disable display-shift
	call	OutLcdControl
	movlw	B'00000011'	; 8 cursor home, cursor home
	call	OutLcdControl
	movlw	B'00001111'	; 9 display on
	call	OutLcdControl
	MOVLW	B'00001100'	; zakazanie blikania kurzora
	call	OutLcdControl
	return

; Inicializacia displaya
Control8Bit
	movwf	PORTB
	bsf	PORTB, LcdE
	nop
	bcf	PORTB, LcdE
	movlw	D'10'
	movwf	loops
	call 	WAIT
	return


; Posuvanie kurzora a podobne...
OutLcdControl
	movwf	LcdDaten
	call	LcdBusy
	movf	LcdDaten, w
	andlw	H'F0'
	movwf	PORTD		; Hi-data zpis
	bsf	PORTC, LcdE
	nop
	bcf	PORTC, LcdE	; Disable LcdBus
	swapf	LcdDaten, w
	andlw	H'F0'
	movwf	PORTD		; Lo-data zpis
	bsf	PORTC, LcdE
	nop
	bcf	PORTC, LcdE	; Disable LcdBus
	return
;--------------------------------------------------------------
;------------------------------------ LCD Bussy control
LcdBusy
        bsf     STATUS, RP0	; nastav Port B4..7 input
	movlw	B'11110000'
	iorwf   TRISB, f 
        bcf     STATUS, RP0
BusyLoop		
	bcf	PORTC, LcdRs
	bsf	PORTC, LcdRW	; tanie
	bsf	PORTC, LcdE
	nop
	movf	PORTD, w
	movwf	LcdStatus
	bcf	PORTC, LcdE
	nop
	bsf	PORTC, LcdE	; Enable
	nop
	bcf	PORTC, LcdE
	btfsc	LcdStatus, 7	; test bit 7
	goto	BusyLoop
	bcf	PORTC, LcdRW
        bsf     STATUS, RP0	; natav Port B4..7 output
	movlw	B'00001111'
	andwf   TRISB, f    
        bcf     STATUS, RP0
	return	


;--------------------------------------------------------------


; Zapis dat do displaya
	
OutLcdNumber			; pripocita 48 pre cisla
	movwf	LcdDaten
	MOVLW	48
	XORWF	LcdDaten,W
OutLcdDaten			; zapis znakov
	movwf	LcdDaten
	call	LcdBusy
	movf	LcdDaten, w
	andlw	H'F0'
	movwf	PORTD		; Zapis hornych 4 bitov
	bsf	PORTC, LcdRs	; Data
	bsf	PORTC, LcdE	; Enable LcdBus
	nop
	bcf	PORTC, LcdE	; Disable LcdBus	
	swapf	LcdDaten, w
	andlw	H'F0'
	movwf	PORTD		; Zapis spodnych 4 bitov
	bsf	PORTC, LcdRs	; Data
	bsf	PORTC, LcdE
	nop
	bcf	PORTC, LcdE	; Disable LcdBus	
	bcf	PORTC, LcdRs	;
	return

; program wait pre display
WAIT
top      movlw   .110           ; Pauza (1ms)
         movwf   loops2
top2     nop                    ; wait
         nop
         nop
         nop
         nop
         nop
         decfsz  loops2, F      ; complete?
         goto    top2           ; no, opakuj 
                                ;
         decfsz  loops, F       ; outer loops complete?
         goto    top            ; no, opakuj 
         retlw   0              ; yes, return

; zmena smeru rotacie cyklicka (ping-pong)
UPDOWN	BTFSS	DIR
	GOTO	$+3
	BCF	DIR
	RETURN
	BSF	DIR
	RETURN
	
; Zobrazenie pre nastavovanie hodnot
	
DISPNASTAV
	MOVLW	B'11000000'
	MOVWF	kurzor			;posunut kurzoru na udanou polohu
	CALL	OutLcdControl

	movfw	UDSTO
	call	OutLcdNumber
	movfw	UDDES
	call	OutLcdNumber
	movfw	UDJED
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movfw	RDEFDES
	call	OutLcdNumber
	movfw	RDEFJED
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movfw	DSTOP
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movfw	FOTDES
	call	OutLcdNumber
	movfw	FOTJED
	call	OutLcdNumber
	
	movlw	B'11111111'
	call	OutLcdDaten
	
DIRECT	MOVLW	0		; zobrazenie smeru rotacie
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	GOTO	RIGHT
	MOVLW	1
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	GOTO	LEFT
	MOVLW	2
	XORWF	NASTR,W
	BTFSC	STATUS,Z
	GOTO	PIPO
RIGHT	movlw	'>'
	call	OutLcdDaten
	goto	FULLHALF
LEFT	movlw	'<'
	call	OutLcdDaten
	goto	FULLHALF
PIPO	movlw	B'00000000'
	call	OutLcdDaten
FULLHALF
	MOVLW	0
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	GOTO	LHFULL
	MOVLW	1
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	GOTO	LHHALF
LHFULL	movlw	'H'
	call	OutLcdDaten
	RETURN
LHHALF	movlw	'F'
	call	OutLcdDaten
	RETURN

DISPZOBRAZ
	MOVLW	B'10000000'
	MOVWF	kurzor			;posunut kurzoru na udanou polohu
	CALL	OutLcdControl	

	movlw	'D'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten	
	movlw	'G'
	call	OutLcdDaten
	movlw	':'
	call	OutLcdDaten
	movfw	POCST2
	call	OutLcdNumber
	movfw	POCDE2
	call	OutLcdNumber
	movfw	POCJE2
	call	OutLcdNumber	
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten	
	movlw	'U'
	call	OutLcdDaten
	movlw	'M'
	call	OutLcdDaten
	movlw	':'
	call	OutLcdDaten
	movfw	POCSTO
	call	OutLcdNumber
	movfw	POCDES
	call	OutLcdNumber
	movfw	POCJED
	call	OutLcdNumber
	MOVLW	B'11000000'
	MOVWF	kurzor			;posunuty kurzoru na udanou polohu
	CALL	OutLcdControl
	movfw	UDSTO
	call	OutLcdNumber
	movfw	UDDES
	call	OutLcdNumber
	movfw	UDJED
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movfw	RDEFDES
	call	OutLcdNumber
	movfw	RDEFJED
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movfw	DSTOP
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movfw	FOTDES
	call	OutLcdNumber
	movfw	FOTJED
	call	OutLcdNumber
	movlw	B'11111111'
	call	OutLcdDaten
	BTFSS	DIR
	GOTO 	LEFT2
RIGH2	movlw	'>'
	call	OutLcdDaten
	GOTO	FULLHAL2
LEFT2	movlw	'<'
	call	OutLcdDaten
FULLHAL2
	MOVLW	0
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	GOTO	LHFUL2
	MOVLW	1
	XORWF	LOHI,W
	BTFSC	STATUS,Z
	GOTO	LHHAL2
LHFUL2	movlw	'H'
	call	OutLcdDaten
	RETURN
LHHAL2	movlw	'F'
	call	OutLcdDaten
	RETURN

IMPULSES	
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	'P'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten
	movlw	'S'
	call	OutLcdDaten	
	movlw	'E'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	'Q'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten	
	movlw	'A'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten	
	movlw	'T'
	call	OutLcdDaten
	movlw	'I'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'Y'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL
	
SPEED	
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten	
	movlw	'T'
	call	OutLcdDaten
	movlw	'I'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	'S'
	call	OutLcdDaten	
	movlw	'P'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'D'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL

PAUSEDISP	
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten	
	movlw	'P'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten
	movlw	'S'
	call	OutLcdDaten	
	movlw	'E'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL

EXPDISP	
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'X'
	call	OutLcdDaten
	movlw	'P'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten	
	movlw	'S'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten	
	movlw	'I'
	call	OutLcdDaten
	movlw	'M'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL

DIRECDISP
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	'D'
	call	OutLcdDaten
	movlw	'I'
	call	OutLcdDaten	
	movlw	'R'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'C'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten	
	movlw	'I'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten	
	movlw	'N'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL

HFSTEP
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	' '
	call	OutLcdDaten
	movlw	'H'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten
	movlw	'F'
	call	OutLcdDaten	
	movlw	'/'
	call	OutLcdDaten
	movlw	'F'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten	
	movlw	'L'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten	
	movlw	'S'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'P'
	call	OutLcdDaten
	movlw	' '

	call	OutLcdDaten
	MOVFW	kurzor
	CALL	OutLcdControl	
	GOTO	TL

DISPMANUAL
	MOVLW	B'11000000'
	CALL	OutLcdControl
	movlw	B'00000001'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	'M'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten	
	movlw	'A'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten
	movlw	' '

	call	OutLcdDaten
	movlw	'C'
	call	OutLcdDaten	
	movlw	'O'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten	
	movlw	'T'
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten
	RETURN

DISPSETUP
	MOVLW	B'11000000'
	CALL	OutLcdControl
	movlw	B'00000000'
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	'S'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten	
	movlw	'P'
	call	OutLcdDaten
	RETURN
	
DISPRUN
	MOVLW	B'11000000'
	CALL	OutLcdControl
	movlw	B'00000010'
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten
	movlw	'U'
	call	OutLcdDaten
	movlw	'N'
	call	OutLcdDaten	
	movlw	' '
	call	OutLcdDaten
	movlw	'P'
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten
	movlw	'O'
	call	OutLcdDaten	
	movlw	'G'
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten	
	movlw	'A'
	call	OutLcdDaten
	movlw	'M'
	call	OutLcdDaten
	RETURN

WELCOM
	MOVLW	B'10000000'
	CALL	OutLcdControl	
	movlw	'P'
	call	OutLcdDaten
	movlw	'E'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten	
	movlw	'E'
	call	OutLcdDaten
	movlw	'@'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	'A'
	call	OutLcdDaten	
	movlw	'D'
	call	OutLcdDaten
	movlw	'Y'
	call	OutLcdDaten	
	movlw	'K'
	call	OutLcdDaten
	movlw	'.'
	call	OutLcdDaten
	movlw	'S'
	call	OutLcdDaten
	movlw	'K'
	call	OutLcdDaten
	MOVLW	B'11000000'
	CALL	OutLcdControl	
	movlw	'v'
	call	OutLcdDaten
	movlw	'e'
	call	OutLcdDaten
	movlw	'r'
	call	OutLcdDaten
	movlw	':'
	call	OutLcdDaten
	movlw	'1'
	call	OutLcdDaten
	movlw	'.'
	call	OutLcdDaten
	movlw	'1'
	call	OutLcdDaten
	RETURN



;---------MANUALNE OVLADANIE ROTACIE----------
DISPMAN
	MOVLW	B'10000000'
	MOVWF	kurzor			;posunut kurzoru na udanou polohu
	CALL	OutLcdControl	
	movlw	'I'
	call	OutLcdDaten
	movlw	'M'
	call	OutLcdDaten	
	movlw	'P'
	call	OutLcdDaten
	movlw	':'
	call	OutLcdDaten
	
	MOVLW	0		; zobrazenie smeru rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	RIGHTM0
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	LEFTM0
RIGHTM0	movlw	' '
	call	OutLcdDaten
	goto	$+3
LEFTM0	movlw	'-'
	call	OutLcdDaten
	movfw	POCSTO
	call	OutLcdNumber
	movfw	POCDES
	call	OutLcdNumber
	movfw	POCJED
	call	OutLcdNumber	
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	B'11111111'
	call	OutLcdDaten
	MOVLW	0		; zobrazenie smeru rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	RIGHTM
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	LEFTM
	
RIGHTM	movlw	'>'
	call	OutLcdDaten
	movlw	'>'
	call	OutLcdDaten
	movlw	B'11111111'
	call	OutLcdDaten
	RETURN
LEFTM	movlw	'<'
	call	OutLcdDaten
	movlw	'<'
	call	OutLcdDaten
	movlw	B'11111111'
	call	OutLcdDaten
	RETURN


MANUAL
	MOVLW	B'00000001'		;ZMAZE CELU OBRAZOVKU
	CALL	OutLcdControl	

	MOVLW	B'11000000'
	CALL	OutLcdControl	
	movlw	'<'
	call	OutLcdDaten
	movlw	'<'
	call	OutLcdDaten
	movlw	'L'
	call	OutLcdDaten	
	movlw	'E'
	call	OutLcdDaten
	movlw	'F'
	call	OutLcdDaten
	movlw	'T'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten	
	movlw	B'11111111'
	call	OutLcdDaten
	movlw	' '
	call	OutLcdDaten
	movlw	'R'
	call	OutLcdDaten	
	movlw	'I'
	call	OutLcdDaten
	movlw	'G'
	call	OutLcdDaten
	movlw	'H'
	call	OutLcdDaten	
	movlw	'T'
	call	OutLcdDaten
	movlw	'>'
	call	OutLcdDaten	
	movlw	'>'
	call	OutLcdDaten

	MOVLW	0
	MOVWF	NASTR2
	

TL2	CALL	DISPMAN	
TL2SMYC	BTFSC	PORTA,4		
	GOTO	TLLEFT2		;vlavo
	BTFSC	PORTA,5
	GOTO	TLRIGHT2	;vpravo
	BTFSC	PORTA,6
	GOTO	TLUP		;hore
	BTFSC	PORTA,7
	GOTO	TLDOWN		;dole
	BTFSC	PORTB,0
	GOTO	TLENT		;ENTER	
	
	MOVLW	3		;Defaultna rychlost rotacie
	MOVWF	ZRYCHL	
	GOTO	TL2SMYC

TLLEFT2	
	BCF	DIR
	MOVLW	0		;  smer rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	TLLEFT
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	TLRIGHT

TLRIGHT2
	BSF	DIR
	MOVLW	0		;  smer rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	TLRIGHT
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	TLLEFT



TLLEFT
	
POCIT3	MOVLW	D'0'		
	XORWF	POCJED,W		
	BTFSC	STATUS,Z		
	GOTO	POCD3	
	DECF	POCJED,f
	GOTO	ROTMAN

POCD3	MOVLW	D'0'		
	XORWF	POCDES,W		
	BTFSC	STATUS,Z		
	GOTO	POCS3	
	DECF	POCDES,f
	MOVLW	D'9'
	MOVWF	POCJED
	GOTO	ROTMAN

POCS3	MOVLW	D'0'		
	XORWF	POCSTO,W		
	BTFSC	STATUS,Z		
	GOTO	POCRE3	
	DECF	POCSTO,f
	MOVLW	D'9'
	MOVWF	POCJED
	MOVLW	D'9'
	MOVWF	POCDES
	GOTO	ROTMAN

POCRE3	
	MOVLW	0		;  smer rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	SET1
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	SET0

TLRIGHT
	
POCIT4	MOVLW	D'9'		
	XORWF	POCJED,W		
	BTFSC	STATUS,Z		
	GOTO	POCD4	
	INCF	POCJED,f
	GOTO	ROTMAN

POCD4	MOVLW	D'9'		
	XORWF	POCDES,W		
	BTFSC	STATUS,Z		
	GOTO	POCS4	
	INCF	POCDES,f
	CLRF	POCJED
	GOTO	ROTMAN

POCS4	MOVLW	D'9'		
	XORWF	POCSTO,W		
	BTFSC	STATUS,Z		
	GOTO	POCRE4	
	INCF	POCSTO,f
	CLRF	POCJED
	CLRF	POCDES
	GOTO	ROTMAN

POCRE4	MOVLW	0		;  smer rotacie
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	SET1
	MOVLW	1
	XORWF	NASTR2,W
	BTFSC	STATUS,Z
	GOTO	SET0
	

TLUP
	clrf	POCJED
	clrf	POCDES
	clrf	POCSTO
	call	TIMER3
	GOTO	TL2
TLDOWN
	
	MOVFW	POCJED
	MOVWF	UDJED
	MOVFW	POCDES
	MOVWF	UDDES
	MOVFW	POCSTO
	MOVWF	UDSTO
	MOVFW	NASTR2
	MOVWF	NASTR
	
	movlw	D'255'		; opozdenie pre tlacitka
	movwf	loops	
	CALL	WAIT
	GOTO	TLZOB

TLENT
	movlw	D'255'		; opozdenie pre tlacitka
	movwf	loops	
	CALL	WAIT
	GOTO	TLZOB

SET1	MOVLW	1
	MOVWF	NASTR2
	INCF	POCJED,f
	GOTO	ROTMAN
SET0	MOVLW	0
	MOVWF	NASTR2
	INCF	POCJED,f
	GOTO	ROTMAN

ROTMAN	
	CALL	TOC
	MOVLW	1
	XORWF	ZRYCHL,W
	BTFSC	STATUS,Z		
	GOTO	TL2
	DECF	ZRYCHL,f
	movfw	ZRYCHL		; opozdenie pre tlacitka
	movwf	loops	
	CALL	TIMER4
	GOTO	TL2

TIMER4	MOVLW	1
	MOVWF	COUNTB
	MOVLW	1
	MOVWF	COUNTA
LOOP4	
	DECFSZ	COUNTA,1
	GOTO	LOOP4
	DECFSZ	COUNTB,1
	GOTO	LOOP4
	DECFSZ	loops,1
	GOTO	LOOP4
	RETURN	
 
	
;-----------------ZAPIS/CITANIE EEPROM

PISEE	movlw	D'100'		; opozdenie pre tlacitka
	movwf	loops	
	CALL	WAIT
	
	btfsc	EECON1,WR	; je zpis u dokonen? 
	goto	$-1		; aknie na dokonenie zpisu 
	movf	EADR,0		; prprava adresy k taniu do W 
	bsf	STATUS,RP0	; volba banky 1 
	movwf	EEADR		; nastavenie adresy EEPROM 
	bcf	STATUS,RP0	; volba banky 0
	movf	CISLO,0		; priprava dat k zpisu do W 
	bsf	STATUS,RP0	; volba banky 1 
	movwf	EEDATA		; nastavenie dat k zpisu do EEPROM
	bsf	EECON1,WREN	; povolenie zpisu do EEPROM 
	movlw	H'55'		; 1. odomykac kd 
	movwf	EECON2		; zpis 1. kdu 
	movlw	H'AA'		; 2. odomykac kd 
	movwf	EECON2		; zpis 2. kdu 
	bsf	EECON1,WR	; zapnutie poiadavku k zpisu bajtu 
	bcf	EECON1,WREN	; zkaz dalieho zpisu do EEPROM 
	bcf	STATUS, RP0
	return

;--------------------------------------------------------

CTIEE	movf	EADR,W		; prprava adresy k taniu do W 
	bsf	STATUS,RP0	; volba banky 1 
	movwf	EEADR		; nastavenie adresy EEPROM 
	bsf	EECON1,RD	; zapnutie poiadavku k taniu bajtu 
	movf	EEDATA,W	; natanie bajtu do registru W 
	bcf	STATUS,RP0	; volba banky 0 
	return
	
END
